import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The object that you move around. includes all of the pysics of the game.
 * 
 * @author Stephen H.
 * @version lolz I lost track
 */
public class Player extends Actor
{
    int YVelocity, XVelocity;
    int YVelocityTimer, XVelocityTimer;
    int waterJump = 0;
    boolean inWater = false;
    boolean onIceRight, onIceLeft;
    int level;
    int timer1, timer2;
    char moving;
    
    /**
     * gets the level that the player has reached and sets it to the variable level
     */
    public Player(int x)
    {
        level = x;
    }
    
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if (level >= 0)
        {
            moveMe();
            die();
        }
        else
        {
            scrollerMoveMe();
            scrollerDie();
        }
        physics();
        nextLevel();
    }    
    
    /**
     * accepts input and moves the player
     */
    public void moveMe()
    {
        if (Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("d"))
        {
            Actor Ice = getOneObjectAtOffset(0, -22, Ice.class);
            if (canMoveRight())
            {
                setLocation(getX() + 2, getY());
            }
            if (Ice != null)
            {
                onIceRight = true;
            }
        }
        else if (Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("a"))
        {
            Actor Ice = getOneObjectAtOffset(0, -22, Ice.class);
            if (canMoveLeft())
            {
                setLocation(getX() - 2, getY());
            }
            if (Ice != null)
            {
                onIceLeft = true;
            }
        }
        
        if (Greenfoot.isKeyDown("space"))
        {
            Actor Water = getOneObjectAtOffset(0, 0, Water.class);
            if (Water == null && atGround())
            {
                Greenfoot.playSound("boink.mp3");
                setLocation(getX(), getY() - 5);
                YVelocity = 8;
                YVelocityTimer = 50;
            }
            else if (Water != null)
            {
                waterJump = 1;
            }
        }  
    }
    
    public void scrollerMoveMe()
    {
        Actor Ice = getOneObjectAtOffset(0, -22, Ice.class);
        if(Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("d"))
        {
            if (canMoveRight())
            {
                moving = 'R';
            }
            if (Ice != null)
            {
                onIceRight = true;
            }
        }
        else if (Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("a"))
        {
            if (canMoveLeft())
            {
                moving = 'L';
            }
            if (Ice != null)
            {
                onIceLeft = true;
            }
        }
        else
        {
            moving = 'N';
        }
        
        if (Greenfoot.isKeyDown("space"))
        {
            Actor Water = getOneObjectAtOffset(0, 0, Water.class);
            if (Water == null && atGround())
            {
                Greenfoot.playSound("boink.mp3");
                setLocation(getX(), getY() - 5);
                YVelocity = 8;
                YVelocityTimer = 50;
            }
            else if (Water != null)
            {
                waterJump = 1;
            }
        }  
    }
    
    //this is where all the good stuff happens :D
    /**
     * does all of the things that add gravity, jumping and most of the other player related
     * systems in the game.
     */
    public void physics()
    {
        //these just make all of the stuff involving some other classes alot easier
        Actor Water = getOneObjectAtOffset(0, 0, Water.class); 
        Actor Ice = getOneObjectAtOffset(0, -22, Ice.class);
        
        // tests if the player is not pressing space and if waterJump == 1
        if (Greenfoot.isKeyDown("space") == false && waterJump == 1)
        {
            waterJump = 0;
        }
        
        if (Greenfoot.isKeyDown("right") == false && onIceRight)
        {
            onIceRight = false;
        }
        if (Greenfoot.isKeyDown("left") == false && onIceLeft)
        {
            onIceLeft = false;
        }
        
        /*
         * tests if you are in water and if it needs to change the inWater variable
         * if you just jumped in it plays the sound "splash.mp3"
         */
        if(Water != null && !inWater)
        {
            inWater = true;
            Greenfoot.playSound("splash.mp3");
        }
        if (Water == null && inWater)
        {
            inWater = false;
        }
        
        // tests if you are on ice and then sets up the sliding stuff
        if (onIceRight)
        {
            XVelocity = 1;
            XVelocityTimer = 50;
        }
        if (onIceLeft)
        {
            XVelocity = -1;
            XVelocityTimer = 50;
        }
        
        // the bit of code that changes your Y velocity depending on weather or not you are jumping in water
        if (Water != null)
        {
            if (waterJump == 0)
            {
                YVelocity = 3;
            }
            else
            {
                YVelocity = 5;
            }
        }
        
        // stops your sliding if you leave ice
        if(Ice == null)
        {
            XVelocity = 0;
            XVelocityTimer = 0;
        }
        
        //not sure why this is here (don't remember) but I'll keep it in just in case
        if (Water != null && waterJump == 1)
        {
            YVelocity = 5;
        }
        
        //this code fixed the bug that mad you get stuck if you were at ground and under water
        if (Water != null && atGround())
        {
            setLocation(getX(), getY() - 1);
        }
        
        //this code makes you move up if you are inside a block
        if (inGround() && atGround())
        {
            setLocation(getX(), getY() - 3);
        }
        
        //makes you fall, this little if statement is the heart of my physics
        if(!atGround())
        {
            setLocation(getX(), getY() - (YVelocity - 4));
        }
        
        //makes you slide if the XVelocityTimer is un equal to 0
        if(XVelocityTimer != 0)
        {
            if (XVelocity > 0 && canMoveRight() || XVelocity < 0 && canMoveLeft())
            {
                if (XVelocityTimer > 20)
                {
                    setLocation(getX() + XVelocity, getY());
                }
                if (XVelocityTimer > 10 && XVelocityTimer < 31)
                {
                    if (timer1 == 0)
                    {
                        setLocation(getX() + XVelocity, getY());
                        timer1++;
                    }
                    else
                    {
                        timer1--;
                    }
                }
                if (XVelocityTimer > 0 && XVelocityTimer < 11)
                {
                    if (timer2 == 0)
                    {
                        setLocation(getX() + XVelocity, getY());
                        timer2 += 2;
                    }
                    else
                    {
                        timer2--;
                    }                
                }
            }
        }
        
        // stops you if at ceiling and sends you down
        if(atCeiling())
        {
            YVelocity = 0;
            YVelocityTimer = 0;
        }
        
        /* this is the jumping system that changes your velocity depending on how long 
         * you have been in the air (I know I should use a switch statment)
         */ 
        if (YVelocityTimer == 40)
        {
            YVelocity = 7;
        }
        else if (YVelocityTimer == 35)
        {
            YVelocity = 6;
        }
        else if (YVelocityTimer == 30)
        {
            YVelocity = 5;
        }
        else if (YVelocityTimer == 20)
        {
            YVelocity = 4;
        }
        else if (YVelocityTimer == 15)
        {
            YVelocity = 3;            
        }
        else if (YVelocityTimer == 10)
        {
            YVelocity = 2;           
        }
        else if (YVelocityTimer == 5)
        {
            YVelocity = 1;            
        }
        else if (YVelocityTimer == 0)
        {
            YVelocity = 0;            
        }
        
        //this simply decreases the YVelocityTimer variable once every act
        if(YVelocityTimer != 0)
        {
            YVelocityTimer--;
        }
        
        /* 
         * this is the code that makes you stop sliding
         */
        if (XVelocityTimer == 0)
        {
            XVelocity = 0;
        }
        
        //this simply decreases the XVelocityTimer variable once every act
        if(XVelocityTimer != 0)
        {
            XVelocityTimer--;
        }
        
        if (pushedByScrollingBlockRight())
        {
            moving = 'L';
        }
        else if(inBlockRight())
        {
            setLocation(getX() - 2, getY());
            moving = ' ';
        }
        
        if (pushedByScrollingBlockLeft())
        {
            moving = 'R';
        }
        else if(inBlockLeft())
        {
            setLocation(getX() + 2, getY());
            moving = ' ';
        }
    }
    
    /**
     * sets the world when the player reaces the end of a world
     */
    public void nextLevel()
    {
        // this switches the level every time yo reach the end of a world
        if (getX() >= 890)
        {
            switch (level)
            {
                case 0:
                    Greenfoot.setWorld(new menu());
                    break;
                case 1:
                    Greenfoot.setWorld(new map2());
                    break;
                case 2:
                    Greenfoot.setWorld(new map3());
                    break;
                case 3:
                    Greenfoot.setWorld(new map4());
                    break;
                case 4:
                    Greenfoot.setWorld(new map5());
                    break;
                case 5:
                    Greenfoot.setWorld(new map6());
                    break;
                case 6:
                    Greenfoot.setWorld(new map7());
                    break;
                case 7:
                    Greenfoot.setWorld(new map8());
                    break;
                case 8:
                    Greenfoot.setWorld(new map9());
                    break;
                case 9:
                    Greenfoot.setWorld(new map10());
                    break;
                case 10:
                    Greenfoot.setWorld(new map11());
                    break;
                case 11:
                    Greenfoot.setWorld(new map12());
                    break;
                case 12:
                    Greenfoot.setWorld(new map13());
                    break;
                case 13:
                    Greenfoot.setWorld(new map14());
                    break;
                case 14:
                    Greenfoot.setWorld(new map15());    
                    break;
                case 15:
                    Greenfoot.setWorld(new map16());
                    break;
                case 16:
                    Greenfoot.setWorld(new map17());
                    break;
                case 17:
                    Greenfoot.setWorld(new map18());
                    break;
                case 18:
                    Greenfoot.setWorld(new map19());
                    break;
                case 19:
                    Greenfoot.setWorld(new map20());
                    break;
                case 20:
                    Greenfoot.setWorld(new map0());
                    break;
                default:
                    Greenfoot.setWorld(new map0());
                break;
            }
        }
        
        if (level == -1)
        {
            Actor portal = getOneObjectAtOffset(0, -42, FinishPortal.class);
            if (portal != null)
            {
                Greenfoot.setWorld(new map0());
            }
        }
    }
    
    /**
     * resets the player if they are killed
     */
    public void die()
    {
        //resets position if you hit the bottom of a world
        if (getY() >= 597)
        {
            setLocation(25, 498);
            if(level == 13)
            {
                map13 map = (map13) getWorld();
                map.reset();
            }
            else if(level == 14)
            {
                map14 map = (map14) getWorld();
                map.reset();
            }
            else if(level == 15)
            {
                map15 map = (map15) getWorld();
                map.reset();
            }
        }
        
        // resets position if you hit a bug
        Actor bug = getOneObjectAtOffset(0, 0, Bug.class);
        if (bug != null)
        {
            setLocation(25, 498);
        }
    }
    
    /**
     * resets the player if they are killed (scroller version)
     */
    public void scrollerDie()
    {
        //resets position if you hit the bottom of a world
        if (getY() >= 597)
        {
            if(level == -1)
            {
                Greenfoot.setWorld(new scroller1());
            }
            else if(level == -2)
            {
                Greenfoot.setWorld(new scroller2());
            }
            else if(level == -3)
            {
                Greenfoot.setWorld(new scroller3());
            }
            else if(level == -4)
            {
                Greenfoot.setWorld(new scroller4());
            }
        }
        
        // resets position if you hit a bug
        Actor bug = getOneObjectAtOffset(0, 0, Bug.class);
        if (bug != null)
        {
            if(level == -1)
            {
                Greenfoot.setWorld(new scroller1());
            }
            else if(level == -2)
            {
                Greenfoot.setWorld(new scroller2());
            }
            else if(level == -3)
            {
                Greenfoot.setWorld(new scroller3());
            }
            else if(level == -4)
            {
                Greenfoot.setWorld(new scroller4());
            }
        }
    }
    
    /**
     * tests if you are touching a ground block
     */
    public boolean atGround()
    {
        Actor ground = getOneObjectAtOffset(0, -22, ground.class);
        if (ground != null)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    
    /**
     * tests if you are in the ground (used for verticaly moving blocks)
     */
    public boolean inGround()
    {
        Actor ground = getOneObjectAtOffset(0, -30, ground.class);
        if (ground != null)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    /*
     * tests if the player is able to move right 
     */
    public boolean canMoveRight()
    {
        Actor ground = getOneObjectAtOffset(15, -26, ground.class);
        if (ground != null)
        {
            if (inGround() && !inBlockRight())
            {
                return true;
            }
            return false;
        }
        else
        {
            return true;
        }
    }
    
    /**
     * tests if the player can move left
     */
    public boolean canMoveLeft()
    {
        Actor ground = getOneObjectAtOffset(-15, -26, ground.class);
        if (ground != null)
        {
            if (inGround() && !inBlockLeft())
            {
                return true;
            }
            return false;
        }
        else
        {
            return true;
        }
    }
    
    /**
     * tests if the player is at the ceiling or has
     */
    public boolean atCeiling()
    {
        Actor ground = getOneObjectAtOffset(0, -26, ground.class);
        if (ground != null || getY() <= 2)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    /**
     * tests if you are in a block on the right side
     */
    public boolean inBlockRight()
    {
        Actor ground = getOneObjectAtOffset(13, -26, ground.class);
        if (ground != null)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    /**
     * tests if you are in a block on the left side
     */
    public boolean inBlockLeft()
    {
        Actor ground = getOneObjectAtOffset(-13, -26, ground.class); 
        if (ground != null)
        {
            return true;
        }
        else
        {
            return false;
        }       
    }
    
    public boolean pushedByScrollingBlockRight()
    {
        Actor ground = getOneObjectAtOffset(13, -26, ScrollingMovingBlock.class); 
        if (ground != null)
        {
            return true;
        }
        else
        {
            return false;
        }   
    }
    
    public boolean pushedByScrollingBlockLeft()
    {
        Actor ground = getOneObjectAtOffset(-13, -26, ScrollingMovingBlock.class); 
        if (ground != null)
        {
            return true;
        }
        else
        {
            return false;
        }   
    }
    
    public boolean onIce()
    {
        Actor Ice = getOneObjectAtOffset(0, -22, Ice.class);
        if (Ice != null)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    public int getXVelocity()
    {
        return XVelocity;
    }
}
